class UmbracoBaseController {
  constructor() {}

  async run(req, res, next) {
    _render(req, res, next);
  }

  render(req, res, next) {
    _render(req, res, next);
  }
}

var _render = function(req, res, next) {
  var ctx = req.contentContext;

  //override of everything to show a json-only response - for debugging...
  if (ctx.serveAsJson) {
    res.header("Content-Type", "application/json");

    // Avoid Circular reference
    var o = {};
    o.o = o;

    // Note: cache should not be re-used by repeated calls to JSON.stringify.
    var cache = [];
    var str = JSON.stringify(
      ctx.model,
      function(key, value) {
        if (typeof value === "object" && value !== null) {
          if (cache.indexOf(value) !== -1) {
            // Circular reference found, discard key
            return;
          }
          // Store value in our collection
          cache.push(value);
        }
        return value;
      },
      4
    );
    cache = null; // Enable garbage collection
    res.send(str);
  } else {
    res.render(ctx.view, ctx.model, function(err, html) {
      if (err) {
        res.render("umbracodefault", ctx.model);
      } else {
        res.send(html);
      }
    });
  }
};

module.exports = UmbracoBaseController;
